# [559. Maximum Depth of N-ary Tree](https://leetcode.com/problems/maximum-depth-of-n-ary-tree/)

## 题目

Given a n-ary tree, find its maximum depth.

The maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node.

Nary-Tree input serialization is represented in their level order traversal, each group of children is separated by the null value (See examples).

**Example 1**:

![https://assets.leetcode.com/uploads/2018/10/12/narytreeexample.png](https://assets.leetcode.com/uploads/2018/10/12/narytreeexample.png)

    Input: root = [1,null,3,2,4,null,5,6]
    Output: 3

**Example 2**:

![https://assets.leetcode.com/uploads/2019/11/08/sample_4_964.png](https://assets.leetcode.com/uploads/2019/11/08/sample_4_964.png)

    Input: root = [1,null,2,3,4,5,null,null,6,7,null,8,null,9,10,null,null,11,null,12,null,13,null,null,14]
    Output: 5

**Constraints:**

- The total number of nodes is in the range [0, 10000].
- The depth of the n-ary tree is less than or equal to 1000.

## 题目大意

给定一个 N 叉树，找到其最大深度。

最大深度是指从根节点到最远叶子节点的最长路径上的节点总数。

N 叉树输入按层序遍历序列化表示，每组子节点由空值分隔（请参见示例）。

## 解题思路

- 使用广度优先遍历

## 代码

```go

package leetcode

type Node struct {
	Val int
	Children []*Node
}

func maxDepth(root *Node) int {
	if root == nil {
		return 0
	}
	return 1 + bfs(root)
}

func bfs(root *Node) int {
	var q []*Node
	var depth int
	q = append(q, root.Children...)
	for len(q) != 0 {
		depth++
		length := len(q)
		for length != 0 {
			ele := q[0]
			q = q[1:]
			length--
			if ele != nil && len(ele.Children) != 0 {
				q = append(q, ele.Children...)
			}
		}
	}
	return depth
}
```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0500~0599/0557.Reverse-Words-in-a-String-III/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0500~0599/0560.Subarray-Sum-Equals-K/">下一页➡️</a></p>
</div>
